import { get, post, patch, destroy, put } from "config/api";
import { Services } from "engine/services";
const us_get = (route) => get(`${Services.users_management.backend}${route}`);
const us_post = (route, payload) => post(`${Services.users_management.backend}${route}`, payload);
const us_delete = (route, payload) => destroy(`${Services.users_management.backend}${route}`, payload);
const us_put = (route, payload) => put(`${Services.users_management.backend}${route}`, payload);
const us_patch = (route, payload) => patch(`${Services.users_management.backend}${route}`, payload);

export const usersManagementApi = {
	getOrganizationRoles: (searchTerm) => us_get(`api/roles?withPagination=${false}${searchTerm && `&searchText=${searchTerm}`}`),
	addOrganizationRole: (payload) => us_post(`api/roles`, payload),
	deleteOrganizationRoles: (payload) => us_post("api/organizations/roles/delete", payload),
	getOrganizationPermissions: (searchTerm) => us_get(`api/permissions${searchTerm && `?searchText=${searchTerm}`}`),
	assignPermissionsToRole: (payload) => us_put(`api/roles/assign-bulk/permissions`, payload),
	getAllOrganizationUsers: (filters) => us_get(`api/users?${filters}`),
	getUsersTypes: (paginate = false) => us_get(`api/user-types?withPagination=${paginate}`),
	assignRoleToUsers: (payload, typeId = null) => us_put(`api/organization-users/roles${typeId ? `/${typeId}` : ""}`, payload),
	updateOrganizationRole: (payload) => us_patch(`api/roles`, payload),
	getRoleDetails: (roleId) => us_get(`api/roles/${roleId}`),
	removePermissionsFromRole: (payload) => us_post(`api/roles/revoke-bulk/permissions`, payload),
	removeMembersFromRole: (payload) => us_post(`api/organization-users/roles/revoke`, payload),
	deactivateUsersAccounts: (payload) => us_post(`api/organizations/users/deactivate`, payload),
	activateUsersAccounts: (payload) => us_post(`api/organizations/users/activate`, payload),
	getOrganizationUserTypes: (searchTerm) => us_get(`api/user-types${searchTerm && `?searchText=${searchTerm}`}`),
	deleteOrganizationUserType: (id) => us_delete(`api/user-types/${id}`),
	getUserTypeDetails: (userTypeId) => us_get(`api/user-types/${userTypeId}`),
	addOrganizationUserType: (payload) => us_post(`api/user-types`, payload),
	updateOrganizationUserType: (id, payload) => us_patch(`api/user-types/${id}`, payload),
	assignPermissionsToUserType: (payload) => us_put(`api/usertypes/assign-bulk/permissions`, payload),
	assignRolesToUserType: (payload) => us_put(`api/usertypes/assign-bulk/roles`, payload),
	assignUserTypeToUser: (userTypeId, payload) => us_put(`api/organization-users/usertypes/${userTypeId}`, payload),
	removePermissionsFromUserType: (payload) => us_post(`api/usertypes/revoke-bulk/permissions`, payload),
	removeRolesFromUserType: (payload) => us_post(`api/usertypes/revoke-bulk/roles`, payload),
	removeUsersFromUserType: (userTypeId, payload) => us_post(`api/organization-users/usertypes/${userTypeId}/revoke`, payload),
	removeUserFromOrganization: (organizationId, payload) => us_post(`api/organization-users/${organizationId}/users/delete`, payload),
	createUserAccount: (payload) => us_post(`api/register`, payload),
	updateUserAccount: (userId, payload) => us_patch(`api/users/${userId}`, payload),
	assignRolesToUsers: (typeId, payload) => us_put(`api/organization-users/roles/${typeId}`, payload),
	assignPermissonsToUsers: (typeId, payload) => us_put(`api/organization-users/permissions/${typeId}`, payload),
	removeRolesFromUsers: (typeId, payload) => us_post(`api/organization-users/roles/revoke/${typeId}`, payload),
	removePermissionsFromUsers: (typeId, payload) => us_post(`api/organization-users/permissions/revoke/${typeId}`, payload),
	getUserDetails: (userId) => us_get(`api/users/${userId}`),
	exportUsers: () => get(`${Services.users_management.backend}api/export/users`, { responseType: "blob" }),
	downloadUsersTemplate: () => get(`${Services.users_management.backend}api/import/template/users`, { responseType: "blob" }),
	exportRoles: () => get(`${Services.users_management.backend}api/export/roles`, { responseType: "blob" }),
	downloadRolesTemplate: () => get(`${Services.users_management.backend}api/import/template/roles`, { responseType: "blob" }),
	getUsersGroups: (searchTerm) => us_get(`api/user-groups${searchTerm && `?searchText=${searchTerm}`}`),
	deleteUserGroup: (userGroupId) => us_delete(`api/user-groups/${userGroupId}`),
	addUserGroup: (payload) => us_post(`api/user-groups`, payload),
	updateUserGroup: (userGroupId, payload) => us_patch(`api/user-groups/${userGroupId}`, payload),
	assignRolesToUserGroup: (payload) => us_put(`api/user-groups/roles`, payload),
	removeRolesFromUserGroup: (payload) => us_post(`api/user-groups/roles/remove`, payload),
	assignPermissionsToUserGroup: (payload) => us_put(`api/user-groups/permissions`, payload),
	removePermissionsFromUserGroup: (payload) => us_post(`api/user-groups/permissions/remove`, payload),
	addMembersToUserGroup: (userGroupId, payload) => us_put(`api/user-groups/${userGroupId}/users`, payload),
	removeMembersFromUserGroups: (userGroupId, payload) => us_post(`api/user-groups/${userGroupId}/users/remove`, payload),
};
